// Datoteka zad1.cpp
#include "aes.h"
#include "aes_proc.h"
#include <iostream>

// Ukljucujemo prostore imena esa i std
using namespace aes;
using namespace std;

// Vremenski trenuci dolaska korisnika (Tabela 1)
double vreme_dolaska[] = { 0.0, 1.0, 1.0, 1.0, 2.0, 4.0,
                           4.0, 4.0, 4.0, 5.0, 5.0, 6.0, 8.0 };
// Vreme opsluge korisnika (Tabela 1)
double vreme_opsluge[] = { 4.0, 3.0, 4.0, 3.0, 1.0, 4.0, 
                           2.0, 1.0, 2.0, 1.0, 1.0, 1.0, 3.0 };

// Objekat reda cekanja
red salt_red;
// Salteri
resurs salteri(4);
// Objekat simulacije
simulacija simu;

// Klasa korisnika
class korisnik:public agent {
  // Brojac korisnika
  static size_t _idc;    
  // Redni broj korisnika
  size_t _id;    
public:
  // Konstruktor
  korisnik():agent() { _id = ++_idc; }
public:
  // Vraca id korisnika
  size_t vrati_id() { return _id; } 
}; 
size_t korisnik::_idc = 0;

class dolazak_korisnika:public dogadjaj {
public:
  // Konstruktor
  dolazak_korisnika():dogadjaj(1) {}
  // Akcija
  void akcija();
  // Pomocna funkcija za pravljenje dogadjaja 
  static dolazak_korisnika* napravi(korisnik* kor,vreme vn) {
    dolazak_korisnika* dk = new dolazak_korisnika;
    dk->postavi_agenta(0,kor);
    dk->postavi_vreme(vn);
    return dk;
  }
};

class odlazak_korisnika:public dogadjaj {
public:
  // Konstruktor
  odlazak_korisnika():dogadjaj(1) {}
  // Akcija dogadjaja
  void akcija();
  // Pomocna funkcija za pravljenje dogadjaja
  static odlazak_korisnika* napravi(korisnik* kor,vreme vn) {
    odlazak_korisnika* ok = new odlazak_korisnika;
    ok->postavi_agenta(0,kor);
    ok->postavi_vreme(simu.vrati_vreme()+vn);
    return ok;
  }
};

#ifdef STAMPA
void aes::stampaj_red() { 
  for(size_t i=0; i<salt_red._broj; ++i) {
    cout << dynamic_cast<korisnik*>(salt_red._red[i])->vrati_id();
    if(i<salt_red._broj-1)
      cout << ",";
  }
}

void aes::stampaj_lbd() { 
  for(size_t i=0;i<simu._broj;++i) {
    odlazak_korisnika* ok = dynamic_cast<odlazak_korisnika*>(simu._lbd[i]);
    if(ok) {
      cout << dynamic_cast<korisnik*>(simu._lbd[i]->vrati_agenta(0))->vrati_id();
      if(i<simu._broj-1)
        cout << ",";
    }
  }
}
#endif

// Akcija
void dolazak_korisnika::akcija() {
  korisnik *kor,*prvi_kor,*novi_kor;
  // Korisnik koji dolazi u postu
  kor = dynamic_cast<korisnik*>(vrati_agenta(0));
  #ifdef STAMPA
  // Stampa u izvestaj
  cout << simu.vrati_vreme() << ": Korisnik " << kor->vrati_id() << " dolazi u postu." << endl;
  #endif
  // Postavi klijenta u red cekanja
  salt_red.smesti(kor);
  // Ukoliko je salter raspoloziv
  if(salteri.raspoloziv()) {
    // Izvadi prvog klijenta iz reda
    prvi_kor = dynamic_cast<korisnik*>(salt_red.prednji());
    // Prvi korisnik izlazi iz reda
    salt_red.vadi();
    // Zauzmi jedno mesto u salteru
    salteri.zauzmi();
    // Rasporedi klijenta za kraj opsluge 
    simu.rasporedi(odlazak_korisnika::napravi(prvi_kor,vreme_opsluge[prvi_kor->vrati_id()-1]));
  }
  #ifdef STAMPA
  // Stampa u izvestaj
  cout << simu.vrati_vreme() << ": Korisnici u redu: "; stampaj_red(); cout << endl;
  cout << simu.vrati_vreme() << ": Korisnici u sistemu: "; stampaj_lbd(); cout << endl;
  #endif
  // Stvaramo narednog korisnika
  novi_kor = new korisnik;    
  if(novi_kor->vrati_id()<=13) 
    // Postavljamo vreme narednog dolaska
    simu.rasporedi(dolazak_korisnika::napravi(novi_kor,vreme_dolaska[novi_kor->vrati_id()-1]));
  else 
    delete novi_kor;
}

// Akcija dogadjaja
void odlazak_korisnika::akcija() {
  korisnik *kor, *prvi_kor;
  // Korisnik koji odlazi
  kor = dynamic_cast<korisnik*>(vrati_agenta(0));
  // Vrati salter
  salteri.oslobodi();
  #ifdef STAMPA
  // Stampa u izvestaj
  cout << simu.vrati_vreme() << ": Korisnik " << kor->vrati_id() << " odlazi iz poste." << endl;
  #endif
  // Klijent odlazi iz poste - unistavamo tekuceg klijenta
  delete kor;
  // Ukoliko red nije prazan
  if(salt_red.vrati_velicinu()>0) {
    // Izvadi prvog korisnika iz reda
    prvi_kor = dynamic_cast<korisnik*>(salt_red.prednji());
    salt_red.vadi();
    // Zauzmi jedno mesto u salteru
    salteri.zauzmi();
    // Rasporedi klijenta za kraj opsluge 
    simu.rasporedi(odlazak_korisnika::napravi(prvi_kor,vreme_opsluge[prvi_kor->vrati_id()-1]));
  }
  #ifdef STAMPA
  // Stampa u izvestaj
  cout << simu.vrati_vreme() << ": Korisnici u redu: "; stampaj_red(); cout << endl;
  cout << simu.vrati_vreme() << ": Korisnici u sistemu: "; stampaj_lbd(); cout << endl;
  #endif
}

int main() {
  korisnik *kor = new korisnik;
  // Postavljamo prvi dogadja u listu sto je odgovara dolasku prvog klijenta
  simu.rasporedi(dolazak_korisnika::napravi(kor,vreme_dolaska[kor->vrati_id()-1]));
  // Izvrsavamo simulaciju
  simu.izvrsi();
}